;==========================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;==========================
; ZX Spectrum Palette Rotation Routines
; CLEAR 61440
;==========================

@ATTR=5800			;22528, Start of ATTR table
@Size=02C0			;704, ATTR table size-bottom 2 rows

ORG F000

	JR RotIn		;61440, Rotate in
	JR RotOut		;61442, Rotate out
	JR Save			;61444, Save ATTR
	JR Load			;61446, Load ATTR
@Hue
	00			;61448, Search for this color
;====================================================
; Rotate In: POKE 61448, Hue
;====================================================
@RotIn
	LD A,(Hue)		;Search for this color
	LD D,A			;Move to D
	LD HL,ATTR		;ATTR table
	LD BC,Size		;Byte count
@InLup
	LD E,D			;Set E to search value
	LD A,(HL)		;Get ATTR value
	CP E			;Match?
	JR NZ Next		;No, jump
	CP 47			;White?
	JR NZ Skip		;No, jump
	LD E,40			;Change white to blue
@Skip
	INC E			;ATTR=ATTR+1
	LD (HL),E		;Set new ATTR value
@Next
	INC HL			;Next ATTR addr
	DEC BC 			;Decrease counter
	LD A,B 
	OR C 
	LD E,D			;Restore E to search value
	JR NZ InLup		;Loop until BC=0
	RET			;Return 0
;====================================================
; Rotate Out: POKE 61448, Hue
;====================================================
@RotOut
	LD A,(Hue)		;Search for this color
	LD E,A			;Move to E
	LD HL,ATTR		;ATTR table
	LD BC,Size		;Byte count
@OutLup
	LD A,(HL)		;Get ATTR value
	CP E			;Match?
	JR NZ Next2		;No, jump
	CP 41			;Blue?
	JR NZ Skip2		;No, jump
	LD E,48			;Change blue to white
@Skip2
	DEC E			;ATTR=ATTR-1
	LD (HL),E		;Set new ATTR value
@Next2
	INC HL			;Next ATTR addr
	DEC BC 			;Decrease counter
	LD A,B 
	OR C 
	JR NZ OutLup		;Loop until BC=0
	RET			;Return 0
;====================================================
; Save ATTR table
;====================================================
@Save
	LD HL,ATTR		;22528, Start of ATTR table
	LD DE,F100		;Store here
@MuvATTR
	LD BC,Size		;Byte count
	LDIR			;Save/Load ATTR table
	RET			;Return 0
;====================================================
; Load ATTR table
;====================================================
@Load
	LD DE,ATTR		;22528, Start of ATTR table
	LD HL,F100		;Store here
	JR MuvATTR