  10 GO TO 9800
#==============================
#Print patch
# Transfer triangle's vertex coords
# from the matrix to working arrays
# A() and B() then print the triangles.
#==============================
 100 LET Z=0
 110 FOR N=1 TO 3
 120  LET A(N)=X(L,N)+X0
 130  LET B(N)=Y(L,N)+Y0
 140  IF A(N)>256 THEN LET Z=1
 150  IF A(N)>256 OR B(N)>176 THEN RETURN
 160 NEXT N
#Skip draw if black and not spiral arm
 170 IF ST<3 AND A$(1)="0" THEN RETURN
#Draw C triangles
 180 FOR N=1 TO C
 190 PLOT A(1),B(1)
#Draw 3 sides
 200  FOR I=1 TO 3
 210   LET S=I+1
 220   IF S=4 THEN LET S=1
#Set color
 230   IF A$(I)="0" THEN POKE 23677,A(S) : POKE 23678,B(S) : GO TO 260
 240   INK VAL A$(I)
 250   DRAW A(S)-PEEK 23677,B(S)-PEEK 23678
#Scale for next loop
 260   LET Z(I)=RU*A(I)+SU*A(S)
 270   LET W(I)=RU*B(I)+SU*B(S)
 280  NEXT I
#..Load scaled values to working arrays
 290  FOR I=1 TO 3
 300   LET A(I)=Z(I)
 310   LET B(I)=W(I)
 320  NEXT I
#Rotate colors if "LINES"
 330  IF ST=4 THEN LET I$=A$(1) : LET A$=A$(2 TO )+I$
 340 NEXT N
 350 RETURN
#==============================
# Print triangle
#==============================
 400 GO SUB 100
 410  LET L=L+1
 420  IF NOT Z THEN LET C0=C0+1 : IF C0>CM THEN LET C0=1
 430 RETURN
#==============================
# Print menu
#==============================
 500 RESTORE Menu : READ Y1 : READ X1 : INK 4
 501 FOR N=Y1 TO 99
 502  READ W$ : IF W$="EOF" THEN GO TO 505
 503  PRINT AT N,X1;W$
 504 NEXT N
 505 LET Hue=70
# Print hot keys
 510 RESTORE Menu+5
 520 FOR N=1 TO 99
 530  READ I
 540  IF NOT I THEN RETURN
 550  POKE I,Hue
 560 NEXT N
#==============================
#Start
# Adjust parameters using input values
#  SU,RU-Scaling factors
#  Y0-Y offset value
#  CM-Length of color string
#==============================
 900 CLS
 910 LET SU=R/100 : LET RU=1-SU
 920 LET Y0=0 : LET CM=LEN C$
#==============================
# Fill working arrays X() AND Y()
# with vertex values
#==============================
#Col/Row positions
1000 LET L=0 :  LET P=1
1010 FOR S=1 TO 4
# RESTORE patch number
1020  RESTORE 9900+Q(S)
1030  FOR N=P TO P+1
# READ X/Y Vertex coords
1040   FOR I=1 TO 3
1050    READ A
1060    LET X(N,I)=(A+L)*X
1070    READ A
1080    LET Y(N,I)=A*Y
1090   NEXT I
1100  NEXT N
#Col/Row positions
1110  LET L=NOT L
1120  LET P=P+2
1130 NEXT S
#==============================
#Print Quads
#==============================
1200 LET C0=1
1210 FOR H=1 TO YC
#EvenLoop:
1220  LET X0=0
# Even rows
1230  FOR K=1 TO XR STEP 2
1240   LET L=1
1250   GO SUB 2000 : GO SUB 2000
1260   LET X0=X0+X+X
1270  NEXT K
# Odd rows
1300  LET X0=0 : LET Y0=Y0+Y
1310  FOR K=1 TO XR STEP 2
1320   LET L=5
1330   GO SUB 2000 : GO SUB 2000
1340   LET X0=X0+X+X
1350  NEXT K
1360  LET Y0=Y0+Y
1370 NEXT H
#==============================
# Animate?
#==============================
1400 IF CY=1 THEN GO TO 1500
1410 IF CY=4 THEN GO TO 1550
1420 LET N=61440+2*(CY=3)
1425 FOR I=1 TO LEN C$
1430  RANDOMIZE USR N
1440  PAUSE SP
1450  LET SP=SP+(INKEY$="s")-(INKEY$="f") : IF SP=0 THEN LET SP=1
1460  IF INKEY$="q" THEN GO TO 9100
1465  IF INKEY$<>"" THEN GO TO 1465
1470  GO TO 1430
1500 BORDER 4 : PAUSE 100 : BORDER 0
1510 PAUSE 4E4
1530 GO TO 9100
#==============================
#Pulse CYCLE
#==============================
1550 LET I=LEN C$
1560 FOR N=1 TO I
1570  RANDOMIZE USR 61440
1580  PAUSE SP
1600 IF INKEY$="" THEN NEXT N
1610 FOR N=1 TO 7
1620  RANDOMIZE USR 61442
1630  PAUSE SP
1640 NEXT N
1650 LET SP=SP+(INKEY$="s")-(INKEY$="f") : IF SP=0 THEN LET SP=1
1660 IF INKEY$="q" THEN GO TO 9100
1670 IF INKEY$<>"" THEN GO TO 1670
1680 GO TO 1560
#==============================
#Set colors depending on mix style
2000 GO TO 2010*(ST=1)+2100*(ST=2)+2200*(ST=3)+2200*(ST=4)
#==============================
#CASE ST=1: Patch color
#==============================
2010 LET A$=C$(C0)+C$(C0)+C$(C0)
2020 GO SUB 100			: REM Print 1st triangle
2030 LET L=L+1
2040 GO TO 400			: REM Print next triangle
2050 RETURN
#==============================
#CASE ST=2: Triangle color
#==============================
2100 FOR A=1 TO 2
2110  LET A$=C$(C0)+C$(C0)+C$(C0)
2120  GO SUB 400		
2130 NEXT A
2140 RETURN
#==============================
#CASE ST=3 or 4 :Spiral/Line colors
#==============================
2200 FOR A=1 TO 2
2210  LET A$=C$(C0)    : LET C0=C0+1 : IF C0>CM THEN LET C0=1
2220  LET A$=A$+C$(C0) : LET C0=C0+1 : IF C0>CM THEN LET C0=1
2230  LET A$=A$+C$(C0)
2240  GO SUB 400
2250 NEXT A
2260 RETURN
#==============================
# Get key press
#==============================
2500 LET I$=INKEY$
#Convert lowercase to uppercase
2510 IF CODE I$>91 THEN LET I$=CHR$ (CODE I$-32)
#Limit I$ to A to Z
2520 IF I$="" OR I$<"A" OR I$>"Z" THEN GO TO 2500
2530 IF INKEY$<>"" THEN GO TO 2530
2540 LET A=CODE (M$(CODE I$-64))-64
2550 IF A<O THEN GO TO 2500
2560 RETURN 
#==============================
#Quilt, design a quilt
#==============================
3000 PRINT AT 19,0;"\
   Enter four patch numbers.    \
  See Fig. 1 for patch layout.  \
        """"=Random quilt."
3010 INPUT Q$
3020 IF LEN Q$<4 THEN GO SUB 3100
3030 FOR N=1 TO 4
3040  LET I=0
3045  IF Q$(N)>="a" AND Q$(N)<="g" THEN LET Q$(N)=CHR$ (CODE Q$(N)-32)
3050  IF Q$(N)>="1" AND Q$(N)<="9" THEN LET I=VAL Q$(N)
3060  IF Q$(N)>="A" AND Q$(N)<="G" THEN LET I=CODE Q$(N)-55
3070  LET Q(N)=I
3080 NEXT N
3090 GO TO 9100
#==============================
# Random quilt
#==============================
3100 LET Q$="     "
3110 LET M$="123456789ABCDEFG"
3120 RANDOMIZE
3130 FOR N=1 TO 4
3140  LET Q$(N)=M$(RND*15+1)
3150 NEXT N
3160 RETURN
#==============================
# Input routine
#
# Property    VAR Y  X  Min Max Prompt
# Position     1  4  7  10  14  18
# Numeric  I$="O ,03,19,001,005,Octave? (1-5)"
# String   I$="A$,03,19,XXX,XXX,Color Mix?"
#==============================
5000 LET N=21
5010 PRINT AT N,0;D$;AT N,0;I$(18 TO )
5020 LET YP=VAL I$(4 TO 5)
5030 LET XP=VAL I$(7 TO 8)
5040 IF I$(2)="$" THEN GO TO 5200
#Numeric input
5050 INPUT EX
5060 IF EX<VAL I$(10 TO 12) OR EX>VAL I$(14 TO 16) THEN GO TO 5050
5070 PRINT AT N,0;D$
5080 LET VA=PEEK 23637+256*PEEK 23638+55
5090 POKE VA,CODE I$(1)
5100 POKE VA+1,CODE I$(2)
5110 LET XX=EX
5120 IF YP<99 THEN  PRINT AT YP,XP;"    ";AT YP,XP;EX
5130 PRINT AT N,0;D$
5140 RETURN
#String input
5200 INPUT E$
5210 POKE PEEK 23637+256*PEEK 23638+5,CODE I$(1)
5220 LET X$=E$
5230 IF YP<99 THEN PRINT AT YP,XP;"         ";AT YP,XP;E$
5240 GO TO 5130
#==============================
# Start Menu
#==============================
9000 LET Menu=9920 : GO SUB 500
#KEY PRESS   ABCDEFGHIJKLMNOPQRSTUVWXYZ
#VALUE       123456789       B      A
9010 LET M$="ABCDEFGHI       K      J  "
9020 GO SUB 2500
9025 LET T=A
9030 IF T=10 THEN GO TO 3000
9035 IF T=11 THEN PRINT AT 19,7;"""RUN"" to restart." : STOP
#==============================
# Load selected quilt to Q(N)
#==============================
9040 LET I$="211243346587876514235678785699AAGFGF"
9050 LET Q$=I$(1+4*(T-1) TO 4+4*(T-1))
9060 FOR N=1 TO 4
9070  IF Q$(N)>="1" AND Q$(N)<="9" THEN LET Q(N)=VAL Q$(N)
9080  IF Q$(N)>="A" AND Q$(N)<="G" THEN LET Q(N)=CODE Q$(N)-55
9090 NEXT N
#==============================
#Quilt options
# Enter patch parameters
# XR-Patches/Row
# YC-Patches/Column
#==============================
9100 LET XR=INT (255/X)
9110 LET YC=INT (175/Y)
9120 CLS : LET Menu=9930 : GO SUB 500
9130 INK 2 : PRINT AT 0,10;Q$ : INK 4 : LET N=16 : LET M$="                "
9135 PRINT \
AT 4,N;XR;\
AT 5,N;YC;\
AT 6,N;R;\
AT 7,N;C;\
AT 8,N;H$;\
AT 9,N;V$;\
AT 10,N;M$;AT 10,N;("Patch" AND ST=1);("Triangle" AND ST=2);("Spirals" AND ST=3);("Lines" AND ST=4);\
AT 11,N;M$;AT 11,N;("Off" AND CY=1);("Left" AND CY=2);("Right" AND CY=3);("Pulse" AND CY=4);\
AT 12,N;M$;AT 12,N;("FasterSlowerQuit" AND CY<>1);\
AT 13,N;P$
9140 IF CY<>1 THEN LET Menu=9960 : LET Hue=66 : GO SUB 510
#==============================
# Select option loop
#==============================
#  Key Press:ABCDEFGHIJKLMNOPQRSTUVWXYZ
#      Value:8B27C  5    A9 4 13  6
9150 LET M$="HKBGL  E    JI D AC  F    "
9160 PRINT AT 17,1;"Select Option"
9170 GO SUB 2500
9180 IF A=11 THEN GO TO 900
9190 IF A=12 THEN RUN
9200 PRINT AT 17,0;D$
9210 GO TO 9290+10*A
#==============================
# Input Options
#==============================
9300 LET I$="XR,04,16,001,099,Patches/Row?"
9305 GO SUB IP
9306 LET X=255/XR
9307 LET Y=175/YC
9308 GO TO 9140
9310 LET I$="YC,05,16,001,099,Patches/Column?"
9315 GO TO 9305
9320 LET I$="R ,06,16,001,099,Polygon Spacing?"
9322 GO SUB IP
9324 GO TO 9140
9330 LET I$="C ,07,16,001,099,Polygon Count?"
9335 GO TO 9322
#==============================
#Horizontal flip
#==============================
9340 LET I$="214365879ACBDEGF"
9341 LET H$=H$+"X"
9342 PRINT AT 8,16;H$
9343 FOR N=1 TO 4
9344  IF Q$(N)>="1" AND Q$(N)<="9" THEN LET I=VAL Q$(N)
9345  IF Q$(N)>="A" AND Q$(N)<="G" THEN LET I=CODE Q$(N)-55
9346  LET Q(N)=VAL I$(Q(N))
9347 NEXT N
9348 GO TO 9140
#==============================
#Vertical flip
#==============================
9350 LET I$="21437856A9BCEDFG"
9352 LET V$=V$+"X"
9354 PRINT AT 9,16;V$
9356 GO TO  9343
#==============================
#Draw style
#==============================
9360 PRINT AT 17,1;"Patches",," Triangles   (1/2 Patch)"," Spiral Arms (1/3 Patch)"," Lines"
9361 LET Hue=68 : LET Menu=9930 : GO SUB 510 : LET Hue=70 : LET Menu=9940 : GO SUB 510
9362 LET ST=(INKEY$="p")+2*(INKEY$="t")+3*(INKEY$="s")+4*(INKEY$="l")
9363 IF NOT ST THEN GO TO 9362
9364 PRINT AT 17,0;D$;D$;D$;D$
9367 LET Hue=70 : LET Menu=9930 : GO SUB 510
9368 GO TO 9130
#==============================
# Animation
#==============================
9370 PRINT AT 17,1;"Off",," Left Rotate",," Right Rotate",," Pulse"
9371 LET Hue=68 : LET Menu=9930 : GO SUB 510 : LET Hue=70 : LET Menu=9940 : GO SUB 510
9372 LET CY=(INKEY$="o")+2*(INKEY$="l")+3*(INKEY$="r")+4*(INKEY$="p")
9373 IF NOT CY THEN GO TO 9372
9374 GO TO 9364
#==============================
# Color mix
#==============================
9390 LET M$="XBRMGCYW"
9400 FOR N=0 TO 3
9410  PRINT AT 17+N,0;M$(N+1);"="; : INK N   : PRINT "\::\::\::\::\::" : INK 4
9420  PRINT AT 17+N,8;M$(N+5);"="; : INK N+4 : PRINT "\::\::\::\::\::" : INK 4
9430 NEXT N
9440 PRINT AT 17,17;"Color Codes";AT 19,16;"""""=Cancel";AT 20,17;"0=Random Mix"
9450 LET C$=P$
9460 INPUT "Color Mix? ";P$
9470 IF P$="" THEN LET P$=C$
9480 LET C$=""
9490 IF P$="0" THEN GO TO 9700
9500 IF LEN P$=1 THEN LET P$=P$+P$+P$
9510 IF LEN P$=2 THEN LET P$=P$+P$
#            ABCDEFGHIJKLMNOPQRSTUVWXYZ
9520 LET I$=" 15   4     3    2    706"
9530 FOR N=1 TO LEN P$
9540  LET I=CODE P$(N)
9550  IF I=32 THEN LET I=88
#Convert lower case to upper case
9560  IF I>91 THEN LET I=I-32
9570  LET P$(N)=CHR$ (I)
#Locate color code in I$
9580  LET I=I-64
9590  LET A$=I$(I) : IF A$=" " THEN LET A$="0" : LET P$(N)="X"
#Add color code to C$
9600  LET C$=C$+A$
9610 NEXT N
9620 PRINT AT 13,16;D$(17 TO );AT 16,0;D$;D$;D$;D$;D$;D$
9630 IF LEN P$<17 THEN PRINT AT 13,16;P$
9640 IF LEN P$>16 THEN PRINT AT 17,0;"Color Mix: ",,P$
9650 GO TO 9140
#Random color mix
9700 RANDOMIZE
9710 LET I=RND*10+3 : LET P$=""
9720 FOR N=1 TO I
9730  LET P$=P$+M$(INT (RND*7)+2)
9740 NEXT N
9750 GO TO 9520
#==============================
# Initialize VARS
#==============================
#Variables
# Q(N)		-Patch numbers
# X(A,B), Y(C,D)-Vertices of all the triangles
# A(N), B(N)	-Vertices of triangle being drawn
# Z(N), W(N)	-Vertices of scaled triangle
# X 		-Patch width
# Y 		-Patch height
# R 		-Polygon spacing
# C 		-Polygon count
# P$, C$	-Color mix Alpha/Numeric
# ST		-Color mix flag
# H$		-Horizontal flip counter
# V$		-Vertical flip counter
#==============================
#Constants
# D$		-32 spaces
# IP		-5000 input routine
#==============================
# Patch data
#==============================
9800 LET I=61439
9802 IF PEEK 61440<>24 THEN CLEAR 61439
9807 BRIGHT 1: PAPER 0 : BORDER 0 : INK 4 : CLS
9810 DIM Q(4)      : DIM D$(32)
9815 DIM X(8,3)    : DIM Y(8,3)
9820 DIM A(3)      : DIM B(3)
9825 DIM Z(3)      : DIM W(3)
9830 LET O =0      : LET ST=1
9835 LET X =127.5  : LET Y =87.5
9840 LET R =10     : LET C =20
9845 LET P$="RMGC" : LET C$="2345"
9850 LET H$=""     : LET V$=""
9855 LET IP=5000   : LET CY=1 : LET SP=5 : CLS
# Install palette cycle routines
9860 LET I=61440
9865 IF PEEK I=24 THEN GO TO 9000
9870 RESTORE 9970
9875 FOR N=I TO I+999
9880  READ A
9885  IF A=255 THEN GO TO 9000
9890  POKE N,A
9895 NEXT N
9899 STOP
#==============================
#DATA Section
#==============================
#Patch definitions
#==============================
9901 DATA 0,0,0,1,1,0,1,1,1,0,0,1
9902 DATA 0,0,1,1,0,1,1,1,0,0,1,0
9903 DATA 0,0,0,1,1,1,1,1,1,0,0,0
9904 DATA 0,0,1,0,0,1,1,1,0,1,1,0
9905 DATA 0,1,1,0,0,0,0,1,1,0,1,1
9906 DATA 0,0,0,1,1,1,0,0,1,0,1,1
9907 DATA 0,0,1,1,0,1,0,0,1,1,1,0
9908 DATA 0,0,1,0,0,1,1,1,1,0,0,1
9909 DATA 0,0,0,1,1,0,1,0,1,1,0,0
9910 DATA 0,0,1,1,0,1,0,1,1,1,1,0
9911 DATA 0,0,0,1,1,1,1,0,0,1,0,0
9912 DATA 0,0,1,1,1,0,1,0,1,1,0,1
9913 DATA 0,0,1,0,0,1,0,0,1,1,1,0
9914 DATA 0,0,0,1,1,1,0,1,1,0,1,1
9915 DATA 0,1,1,0,0,0,0,0,1,1,0,1
9916 DATA 0,0,1,0,1,1,1,1,1,0,0,1
#==============================
#DATA Section
#==============================
#Quilts menu
9920 DATA 1,8,\
"+--------------+",\
"| Select Quilt |",\
"+--------------+",\
"|   A. 2112    |",\
"|   B. 4334    |",\
"|   C. 6587    |",\
"|   D. 8765    |",\
"|   E. 1423    |",\
"|   F. 5678    |",\
"|   G. 7856    |",\
"|   H. 99AA    |",\
"|   I. GFGF    |",\
"+--------------+",\
"|   X. ????    |",\
"+--------------+",\
"|   Q. Quit    |",\
"+--------------+","EOF"
#Quilt Keys
9925 DATA 22668,22700,22732,22764,22796,22828,22860,\
22892,22924,22988,23052,0
#==============================
#Options Menu
9930 DATA 0,0,\
" Patches: ",\
"---------------",\
" Quilt Options ",\
"---------------",\
"     Row Count:",\
"  Column Count:",\
"       Spacing:",\
"      Polygons:",\
"Horizontl Flip:",\
" Vertical Flip:",\
"    Draw Style:",\
"     Animation:",\
"    Speed Keys:",\
"     Color Mix:",\
"---------------",\
" Begin    Exit","EOF"
#Option Keys
9935 DATA 22661,22690,22727,22758,22784,22817,22852,\
22885,22955,23009,23018,0
#==============================
# Patch Keys
9945 DATA 23073,23105,23137,23169,0
#==============================
# Highlight Speed keys
9965 DATA 22928,22934,22940,0
#==============================
# Palette cycle MC routines
#==============================
9970 DATA 24,6,24,30,24,54,24,64\
,33,0,88,1,192,2,126,254,64,40,8\
,254,71,32,2,62,64,60,119,35,11,\
120,177,32,237,201,33,0,88,1,192\
,2,126,254,64,40,8,254,65,32,2,6\
2,72,61,119,35,11,120,177,32,237\
,201,33,0,88,17,0,241,1,192,2,23\
7,176,201,17,0,88,33,0,241,24,24\
2,255
#Save
9990 CLEAR
9992 SAVE "QUILTS"
9994 RUN
